// This is our javascript, which will pop up our message
// in an new window.

var xmlhttp,selection;
var LEO = "http://dict.leo.org/?//lp=ende&lang=de&searchLoc=0&cmpType=relaxed&relink=on&sectHdr=on&spellToler=std&search=";

function translate()
{
  	if (window.getSelection)
	{
 		//we use XPCNativeWrapper, which makes sure, that the native method of the document will, be called, here getSelection
		var focusedWindow = new XPCNativeWrapper(document.commandDispatcher.focusedWindow, 'window', 'getSelection()');
		selection = focusedWindow.getSelection().toString();
		
		//limit length to 50,longer doesn't make too much sense
		if (selection.length >= 50)
		{
			selection = selection.substring(0, 49);
		}
		
		Request(LEO+selection);
	}
	
}
function Request(url)
{
	if (window.XMLHttpRequest)
	{
  		//PrivilegeManager allows xmlhttprequest to access a website
		netscape.security.PrivilegeManager.enablePrivilege('UniversalBrowserRead');  
		try{
			xmlhttp = new XMLHttpRequest();
			xmlhttp.open("GET" , url , true);
			//it is essential to call XMLHttpReady and not XMLHttpReady()
			xmlhttp.onreadystatechange = XMLHttpReady;
			xmlhttp.setRequestHeader('Accept-Charset','ISO-8859-15');
			//xmlhttp.setRequestHeader('Content-Type','text/xml; charset=ISO-8859-15')
	
			xmlhttp.send(null);

		}catch(e)
		{
			alert(e);
		}
    
	}
	else
	{
		alert("XMLHttp Error");
	}                                                                             
}

function XMLHttpReady()
{
	if (xmlhttp.readyState == 4) //readyState 4 means it's loaded
  	{
		var result;
		response = xmlhttp.responseText; // a string!
		parse(response);
	}
}

function parse(response)
{
	var resultwin = "";
	var start = response.indexOf("ENGLISCH"); //returns "-1" if no instance of ENGLISCH exists (case-sensitive)
	if(start != -1)
	{
		var end = response.indexOf("</form>", start);
		var sub = response.substring(start, end);
		var begin = "<table cellpadding=0 cellspacing=0 width=\"100%\" border=1> <tr> <th colspan=2>";
		begin = begin.concat(sub);  
		begin = begin.replace(/ENGLISCH/, "ENGLISH");
		//deleting all the images
		var img= /<img\s*[^>]*>/ig;
		begin = begin.replace(img, "");
		//deleting the background of the table
		begin = begin.replace(/bgcolor=\"#fff8cc\"/ig,"");
		//deleting links
		var ref= /<a\s*\w+[^>]*>/ig;
		begin = begin.replace(ref, "");       
		result = begin;  
	}
	else 
	{
		result = "<center><h2><i>There were no results for the query of \""+selection+"\".</i></h2></center>";
	}
	resultwin = window.open("responseWin.html","Fuchsfox","width=600,height=500,resizable=yes");
	//start html-header
	resultwin.document.charset = "ISO-8859-15";
	resultwin.document.open();
	resultwin.document.writeln("<html><head>");
	resultwin.document.writeln("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-15\">");
	resultwin.document.writeln("<meta name=\"Author\" content=\"team fuchsfox\">");
	resultwin.document.writeln("<title>Translation of "+selection +"</title>");
	resultwin.document.writeln("</head>");
	//end header & start body
	//resultwin.document.writeln("<body BGCOLOR=\"#ADD8E6\" TEXT=\"#000000\">");
	resultwin.document.writeln("<body background=\"chrome://fuchsfox/skin/background.jpg\">");
	resultwin.document.writeln(result);
	resultwin.document.writeln("</body> </head>");
	resultwin.document.close();
	resultwin.focus();
}